.include "1200def.inc"
.CSEG
.org 0
	rjmp RESET	; Reset Handler
	rjmp int1		; IRQ0 Handler	
	rjmp count     	; Timer1 Capture Handler
	nop 		; Analog Comparator Handler

.def temp = r16
.def temp2 = r17

.def tempsreg = r13
.def potenc = r19

.def count1 = r20 
.def count2 = r18
.def count22 = r10

.def temph = r2
.def templ = r3
.def tr3 = r4
.def tr4 = r5

.def cch = r0
.def ccl =r1
.def hb10 = r25
.def lb10 = r26

.def	m16u2	=r27		;result byte 2
.def	m16u3	=r28		;result byte 3 

.def	drem16uL=r14 ;
.def	drem16uH=r15 ;

.def  	d0 =    r26
.def    d1 =    r25
.def	dd16uL	=r27 ;  
.def	dd16uH	=r28 ;  

.def	dv16uL	=r23 ;
.def	dv16uH	=r24 ;

.def	dcnt16u	=r21 ;
.def 	streg = r29
;========================================================
reset:	cli ;  
	
	
	ldi temp , $40
	out gimsk , temp;   INT0
	
	ldi temp , 2
	out timsk , temp ;  
	
	ldi temp , $58	;  
	out ddrd , temp
	ldi temp , $20
	out portd , temp
	
	ldi temp , 4
	out portb , temp
	ser temp
	out ddrb , temp
	
	ldi temp , 3
	out tccr0 , temp ;     64
	
	ldi temp , 0  
	out acsr , temp
	
	ldi temp , 0
	out wdtcr , temp	
	
	clr streg
	
;==========================================================


a:	sbi ddrd , 1 ;  
	cli
	ldi temp , 3
	out mcucr , temp ;    

	rcall seion ; sei

nopp:	nop
	rjmp nopp
	
;================================================================
int1: ; IRQ0 Handler
	sbrs streg , 1
	rjmp int5
	reti ;  INT0 (  seion :)

int5:	sbis portb , 2 
	rjmp iskra2 ;  
	
	in temp , mcucr
	sbrs temp , 0 ;   
	rjmp intt0 ; 
	
	; 

m8:	
	clr temp
	out tcnt0 , temp ; 
	ldi temp , $2
	out tifr , temp ;  
	clr count22 ; 
		

	ldi temp2 , $0
	out gimsk , temp2;   INT0 

	sei ;rcall seion ; sei  - - -

	sbrs streg , 0 ;   
	rjmp cond0
	rcall miz
	;rcall miz

int1a: ;     		

cond0:
	cbi ddrd , 1 ;  
	in temp , tcnt0
	
cond1:	sbis pind ,0
	rjmp cond1
	
	in potenc , tcnt0
	sub potenc , temp
	sbi ddrd , 1 ;  	
	
;	sbic pind , 5
;	ldi potenc , 100 ;==================
	cpi potenc , 10 
	brsh pot100
	ldi potenc , 100 ;   
pot100:
	
	
	
	cli
	ldi temp , $40
	out gimsk , temp;   INT0
	;============================
	ldi temp , 2
	out mcucr , temp ;     
        ;--------------
	rcall seion ;sei
	
pov11:
	sbic pind , 2 ;========================= 
	rjmp no
	
	rcall timer
	
	sbic pind , 2
	rjmp pov11
	
	rjmp cik1 ;=============??????????  
	
no:	cbi portb , 7 ; indikator pin 19
	
	andi streg ,$fe ;  


n800:	
	mov temp , count22
	cpi temp , $24 ;800  
	brlo n800  ;    800   
		   ;     	
	
	cbi portb , 6 ; indikator pin 18 off
	cli
	
	sbi portb , 7 ; indikator pin 19  800 
	
	ori streg , $1 ;   

cik1:	sbic pind , 2
	rjmp cik1	
	
	cbi portb , 2

	rcall timer

	sbic pind , 2
	rjmp cik1

	rcall timer
	rcall timer
	
cik2:	sbis pind , 2
	rjmp cik2
	nop
	nop
	nop
	sbis pind , 2
	rjmp cik2
	
	sbi portb , 2 ;iskra
	
	;ldi temp , $40
	;out gimsk , temp;   INT0
	rjmp m8
;====================================
intt0:  ; 
	ldi temp , $0
	out gimsk , temp;   INT0
	sei ;rcall seion ; sei

povtor:	in  count1 , tcnt0 
	mov count2 , count22
	in  temp , tcnt0 
	cp count1 , temp
	brne povtor
	cp count2 , count22
	brne povtor
	;clc
	;ror count2
	;ror count1 ;   2
	

	cbi portb , 2

mov temph , count2
mov templ , count1
	

	sbi portb , 6 ; indikator pin 18 on
	cpi count2 , $1d ;1000 o  .16,6
	brlo st1
	cbi portb , 6 ; indikator pin 18 off
	

st1:	; 
	; 4630 =1216 h

	ldi temp  , $12
	clc
	cpi count1 , $16
	cpc count2 , temp
	brlo st2


	clr cch
	clr ccl
	;b10 3700 = e74
	ldi hb10 ,  $e 
	ldi lb10 , $74
	rjmp rasch
	;=================================================	
st2:	cbi portb , 6 ; indikator pin 18 off

	; 
	; 2500 =9c4 h
	ldi temp  , $09
	clc
	cpi count1 , $c4
	cpc count2 , temp
	brlo st3


	; ccc 294  126
	ldi temp , $1
	mov cch , temp
	ldi temp , $26
	mov ccl , temp
	;b10 3853  f0d
	ldi hb10 , $f
	ldi lb10 , $d
	rjmp rasch
	;================================================== 
st3:
 	; 
	; 1389 =56d h
	ldi temp  , $05
	clc
	cpi count1 , $6d
	cpc count2 , temp
	brlo st4
		

	;CCC 143  8f
	ldi temp , $0
	mov cch , temp
	ldi temp , $8f
	mov ccl , temp
	; B1O 3708  e7c
	ldi hb10 , $e
	ldi lb10 , $7c
	rjmp rasch
	;=================================================
st4:
	clr ccl
	clr cch
	; b10 3460 d84
	ldi hb10 , $d
	ldi lb10 , $84
	rjmp rasch


rasch:
	;
	;b10 - potenc
	sub lb10 , potenc
	sbci hb10 , 0

	;
;***************************************************************************
;*
;* "mpy16u" - 16x16 Bit Unsigned Multiplication
;*
;* This subroutine multiplies the two 16-bit register variables 
;* mp16uH:mp16uL and mc16uH:mc16uL.
;* The result is placed in m16u3:m16u2:m16u1:m16u0.
;*  
;* Number of words	:14 + return
;* Number of cycles	:153 + return
;* Low registers used	:None
;* High registers used  :7 (mp16uL,mp16uH,mc16uL/m16u0,mc16uH/m16u1,m16u2,
;*                          m16u3,mcnt16u)	
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	mc16uL	=r16	count1	;multiplicand low byte 
;.def	mc16uH	=r17	count2	;multiplicand high byte
;.def	mp16uL	=r26	lb10	;multiplier low byte
;.def	mp16uH	=r25	hb10	;multiplier high byte
;.def	m16u0	=r26	lb10	;result byte 0 (LSB)
;.def	m16u1	=r25	hb10	;result byte 1
;.def	m16u2	=r27		;result byte 2
;.def	m16u3	=r28		;result byte 3 (MSB)
;.def	mcnt16u	=r16	temp		;loop counter

;***** Code

mpy16u:	clr	m16u3		;clear 2 highest bytes of result
	clr	m16u2
	ldi	temp,16	;init loop counter
	lsr	hb10
	ror	lb10

m16u_1:	brcc	noad8		;if bit 0 of multiplier set
	add	m16u2,count1	;add multiplicand Low to byte 2 of res
	adc	m16u3,count2	;add multiplicand high to byte 3 of res
noad8:	ror	m16u3		;shift right result byte 3
	ror	m16u2		;rotate right result byte 2
	ror	hb10		;rotate result byte 1 and multiplier High
	ror	lb10		;rotate result byte 0 and multiplier Low
	dec	temp		;decrement loop counter
	brne	m16u_1		;if not done, loop more
	;ret


;mov r5 , m16u3 
;mov r6 , m16u2
;mov r7 , hb10
;mov r8 , lb10

;
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*  
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :5 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH,
;*			    dcnt16u)
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	drem16uL=r14 ;
;.def	drem16uH=r15 ;

;.def  	d0 =     r26
;.def    d1 =     r25
;.def	dd16uL	=r27 ;  
;.def	dd16uH	=r28 ;  

;.def	dv16uL	=r16 ;
;.def	dv16uH	=r17 ;

;.def	dcnt16u	=r21 ;

	; 2400 $960
	ldi dv16ul , $60
	ldi dv16uh , $9

;***** Code

div16u:	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,33	;init loop counter
d16u_1:	
	rol     d0
	rol     d1
	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	d16u_2		;if done
	rjmp dend			;    return
d16u_2:	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_3		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	d16u_1		;else
d16u_3:	sec			;    set carry to be shifted into result
	rjmp	d16u_1


dend:

;mov r9 , hb10
;mov r10 , lb10

;
	mov temp  , cch
	mov temp2 , ccl
	clc
	sbc     lb10 , temp2	
	sbc	hb10 , temp



mov tr3 , hb10
mov tr4 , lb10

;==============================================================
;==============================================================
;
;
;==============================================================
; 
	cli
	ldi temp , $40
	out gimsk , temp;   INT0
	ldi temp , 3
	out mcucr , temp ;    
	rcall seion ; sei
	nop
	; 
sr1:	 
	 
	cp hb10 ,count22 
	brlo iskra ; 
	brne sr1 ;  
sr2:	
	in  count1 , tcnt0 
	cp count1 ,lb10 
	brsh iskra
	brlo sr2
	

iskra:	cli
	;ldi temp , 3
	;out mcucr , temp ;    
        
        sbi portb , 2
	;rcall seion ; sei
	
is2:	sbis pind , 2 ;=========================
	rjmp is2
	
	ldi temp , 10
	rcall ttt1	;   
	
	sbis pind , 2 ;         0  1
	rjmp is2      ;=========================
	
	; cli
	
	rjmp m8	
  ;=======================================================	

iskra2: ; 
	ldi temp , $0
	out gimsk , temp;   INT0
	sei ;rcall seion ; sei
	
povtor2:
 	in  count1 , tcnt0
	mov temp , count22
	
	in temp2 , tcnt0
	cp count1 , temp2
	brne povtor2
	cp temp , count22
	brne povtor2

	clc
	sbc lb10 , count1
	sbc hb10 , temp
;===============	
	brlo iskra ; e      
;===============
	clr temp
	out tcnt0 , temp
	ldi temp , $2
	out tifr , temp ;  
	clr count22
	
		; 
sr1a:	 
	 
	cp hb10 , count22 
	brlo iskra3 ; 
	brne sr1a ;  
sr2a:	
	in  count1 , tcnt0 
	cp count1 ,lb10 
	brsh iskra3
	brlo sr2a

iskra3:
        sbi portb , 2
	rjmp int1a	 
;============================================================
;============================================================
;============================================================
count:
	in tempsreg , sreg
	inc count22
	out sreg ,tempsreg
	reti	
		 
;=============================================================

seion : ori streg , $2
	;set
	sei
	nop
	nop
	andi streg ,$fd
	;clt
	ret 

andi streg ,$fe
ori streg , $1
;=============================================================	

;=================================
timer:
	clr temp
ttt1:	inc temp
	brne ttt1
	ret
;=============================================================
miz:	

	ldi temp2 , 156
ttt2a:
	clr temp
ttt1a:	inc temp
	brne ttt1a
	
	inc temp2 
	brne ttt2a 
	
	cbi portb , 2 ;  iskra
	;;;;;;;;;;;;;;;;;;
	
	ldi temp2 , 156
		
ttt2b:		
	clr temp
ttt1b:	
	inc temp
	brne ttt1b
	
	inc temp2 
	brne ttt2b
	
	sbi portb , 2 ;iskra
	ret 	